$$Loop Alerts
$$Message User Alert, u:$Worksheet.name$.cp

$$File u:$Worksheet.name$.cp
/*  $Worksheet.name$								 Handle this alert */
/*  $CopyRight$ */

/*	File name:  $Worksheet.name$
	Function:  Handle this alert.
$$if Alert.Stop
	This is a STOP alert, it is used to inform the user that data is about to be lost.
	It is also used for fatal type errors and tells the user about the error.
$$endif
$$if Alert.Note
	This is a NOTE alert, it is used to inform the user of some general information.
	This alert is not used if there is a possibility of losing any data.
$$endif
$$if Alert.Caution
	This is a CAUTION alert, it is used to inform the user that if the current path
	is taken then data may be lost.  The user can change the present course and
	save the data.  This is the type of alert used to tell the user that he needs to
	save the data before going on.
$$endif

	This alert is called when:

	The choices in this alert allow for:
		
	History: $Date$ Original by $Author$

*/

#include "mmCommon$Prototype.name$.h"	/* Common */
#include "Common$Prototype.name$.h"		/* Common */

/* ======================================================= */
/* ======================================================= */

/* Initialize the alert variables */

void CA$Worksheet.name$::Init()
{
inherited::Init();
}

$$if Option.EXTRAHOOKS
/* ======================================================= */

/* Handle setup necessary for first time in */

void CA$Worksheet.name$::DoFirstTime()
{
inherited::DoFirstTime();
}

/* ======================================================= */

/* Handle item pressed in alert */

void CA$Worksheet.name$::DoItemHit(short itemHit)
{


inherited::DoItemHit(itemHit);

$$Loop Control.type = Button
if (itemHit == ResA_$Control.name$)				/* Handle the Button being pressed */
	{
	}

$$EndLoop Control.type
$$Loop Control.type = UButton
if (itemHit == ResA_$Control.name$)				/* Handle the Button being pressed */
	{
	}

$$EndLoop Control.type
$$Loop Control.type = HotRect
$$if Control.HotSpot
if (itemHit == ResA_$Control.name$)				/* Handle the HotSpot being pressed */
	{
	}

$$endif Control.HotSpot
$$EndLoop
$$Loop Control.type = Picture
$$if Control.NonGraphic
if (itemHit == ResA_$Control.name$)				/* Handle the Picture being pressed */
	{
	}

$$endif Control.NonGraphic
$$EndLoop
$$Loop Control.type = Icon
$$if Control.NonGraphic
if (itemHit == ResA_$Control.name$)				/* Handle the Icon being pressed */
	{
	}

$$endif Control.NonGraphic
$$EndLoop
$$Loop Control.type = Sicn
$$if Control.NonGraphic
if (itemHit == ResA_$Control.name$)				/* Handle the Sicn being pressed */
	{
	}

$$endif Control.NonGraphic
$$EndLoop
}

/* ======================================================= */

$$endif Option.EXTRAHOOKS

/* ======================================================= */
/* ======================================================= */
$$CloseFile
$$EndLoop


