$$Message Marksman Alert, mmAlertObject.cp
$$File mm:mmAlertObject.cp
/*  mmAlertObject				 */
/*  $CopyRight$ */

/*	File name:  mmAlertObject
	Function:  Basic alert object

	History: $Date$ Original by $Author$

*/

#include "mmCommon$Prototype.name$.h"	/* Common */
#include "Common$Prototype.name$.h"		/* Common */


/* ======================================================= */

/* Routine: MyFilter */
/* Purpose: Filter routine, also used for initial setup of dimmed states */

pascal Boolean theAlertFilter(DialogPtr theDialog,EventRecord *theEvent,short *itemHit)
{
Boolean			FilterValue;							/* Temporary return value */


FilterValue = false;
if ((gCurrentAlert != nil) && (!gCurrentAlert->DidFirstTime))	/* Make all controls and do lines and rects */
	{
	gCurrentAlert->theWindow = theDialog;
	gCurrentAlert->DidFirstTime = true;							/* Not first time anymore */
	gCurrentAlert->HandleFirstTime();
	}

FilterValue = gCurrentAlert->FilterThisEvent(theDialog,theEvent,itemHit);	/* Call the user routine */

CheckKeysInDialog(theDialog,&FilterValue,theEvent,itemHit);

return(FilterValue);
}

/* ======================================================= */

/* Handle setup necessary for first time in */

void CmmAlert::Init()
{

inherited::Init();

this->theWindow = nil;				/* Window pointer */
this->DidFirstTime = false;			/* Flag for first time thru the filter */
/* Expected to be overridden by the Alert code */
}

/* ======================================================= */

void CmmAlert::HandleFirstTime()
{
/* Expected to be overridden by the Alert code */
}

/* ======================================================= */

void CmmAlert::DoFirstTime()
{
/* Expected to be overridden by the Alert code */
}

/* ======================================================= */

Boolean CmmAlert::FilterThisEvent(DialogPtr theDialog,EventRecord *theEvent,short *itemHit)
{
Boolean		FilterItOut;
/* Expected to be overridden by the Alert code */
FilterItOut = false;
return(FilterItOut);
}

/* ======================================================= */

void CmmAlert::DoItemHit(short itemHit)
{
/* Expected to be overridden by the Alert code */
}

/* ======================================================= */

void CmmAlert::BringUpAlert()
{
/* Expected to be overridden by the Alert code */
}

/* ======================================================= */
/* ======================================================= */
$$CloseFile


