$$Message User Menu, u:menu$Prototype.name$.h
$$File u:menu$Prototype.name$.h
/*  $CopyRight$ */
/*  menu$Prototype.name$				Handle menus

	File name:  menu$Prototype.name$.h  
	Function:  This contains the routines to handle menus.
	History: $Date$ Original by $Author$

   */

/* ======================================================= */
/* ======================================================= */

#ifdef __cplusplus
extern "C" {
#endif

/* Extra to Initialize the menubar */
void AddExtraMenus(void);

$$Loop Menus
void Do_$Menu.name$Menu(Boolean Doing_Pre,short theItem,Boolean *SkipProcessing);

$$EndLoop Menus
$$Loop HierMenus
void Do_$Menu.name$Menu(Boolean Doing_Pre,short theItem,Boolean *SkipProcessing);

$$EndLoop HierMenus
/* Handle other menu lists */
void Handle_Other_Menus(short theMenu, short theItem);

#ifdef __cplusplus
}
#endif

/* ======================================================= */
/* ======================================================= */
$$CloseFile
$$Message User Menu, u:menu$Prototype.name$.c
$$File u:menu$Prototype.name$.c
/*  $CopyRight$ */
/*  menu$Prototype.name$				Handle menus

	File name:  menu$Prototype.name$.c  
	Function:  This contains the routines to handle menus.
	History: $Date$ Original by $Author$

   */

#include "mmCommon$Prototype.name$.h"	/* Common */
#include "Common$Prototype.name$.h"		/* Common */

#include "menu$Prototype.name$.h"		/* This file */

#pragma segment Menus

/* ======================================================= */
/* ======================================================= */

/* Routine: AddExtraMenus */
/* Purpose: Add in any extra menus */

void AddExtraMenus(void)
{

}

/* ======================================================= */

$$Loop Menus

/* Routine: Do_$Menu.name$Menu */
/* Purpose: Handle any menu items for the $Menu.FullName$ menu. */
/* Get the main handler to ignore this menu item by changing SkipProcessing   to be TRUE. */

void Do_$Menu.name$Menu(Boolean Doing_Pre,short theItem,Boolean *SkipProcessing)
{

*SkipProcessing = FALSE;							/* Set to not skip the processing of this menu item */

switch (theItem)									/* Handle all commands in this menu list */
	{
	$$Loop MenuItems
	case MItem_$MenuItem.name$:						/* For item $MenuItem.FullName$ */
		if (Doing_Pre)
			{
			}
		else
			{
			}
		break;
	$$EndLoop MenuItems
	default:									/* allow other buttons, trap for debug */
		break;								/* end of otherwise */
	}											/* end of switch */

}

/* ======================================================= */
$$EndLoop Menus
$$Loop HierMenus

/* Routine: Do_$Menu.name$Menu */
/* Purpose: Handle any menu items for the $Menu.FullName$ menu. */
/* Get the main handler to ignore this menu item by changing SkipProcessing   to be TRUE. */

void Do_$Menu.name$Menu(Boolean Doing_Pre,short theItem,Boolean *SkipProcessing)
{

*SkipProcessing = FALSE;							/* Set to not skip the processing of this menu item */

switch (theItem)									/* Handle all commands in this menu list */
	{
	$$Loop MenuItems
	case MItem_$MenuItem.name$:						/* For item $MenuItem.FullName$ */
		if (Doing_Pre)
			{
			}
		else
			{
			}
		break;
	$$EndLoop MenuItems
	default:									/* allow other buttons, trap for debug */
		break;								/* end of otherwise */
	}											/* end of switch */

}

/* ======================================================= */
$$EndLoop HierMenus
/* ======================================================= */

/* Routine: Handle_Other_Menus */
/* Purpose: Handle special menus */

void Handle_Other_Menus(short theMenu,short  theItem)
{

}

/* ======================================================= */
/* ======================================================= */
$$CloseFile


